//+------------------------------------------------------------------+
//|                                                        BBRSI.mq4 |
//|                                   Copyleft  2010 Zakharov Vadim |
//|                                                   aka Yuritch    |
//+------------------------------------------------------------------+


#property  indicator_separate_window
#property indicator_buffers   1
#property indicator_color1    Orange
#property indicator_width1      2
#property indicator_levelcolor  Gray

//---- input parameters

extern int period=13;
extern int smooth=24;
extern int mode=2;
extern int price=6;
extern double overbought=80.0;
extern double oversold=20.0;
extern bool ea_feedback=false;

int TF=0;
int depth=1440;
int i, j;
double rsi[],rsima1[],rsima2[],delta[],delta1[],trend[],tmp,weight_sum,weight;
bool Recalculate=true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
{
IndicatorDigits(0);
IndicatorBuffers(6);

   if (ea_feedback)
      {
      period=GlobalVariableGet("period");
      smooth=GlobalVariableGet("smooth");
      price= GlobalVariableGet("a_price");
      mode=  GlobalVariableGet("mode");
      TF=    GlobalVariableGet("trend_tf");
      }
      SetIndexBuffer(0,trend);
      SetIndexStyle(0,DRAW_LINE);
      SetIndexLabel(0,"trend"); 
      SetIndexBuffer(1,delta1);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexLabel(1,NULL);      
      SetIndexBuffer(2,delta);
      SetIndexStyle(2,DRAW_NONE);
      SetIndexLabel(2,NULL);      
      SetIndexBuffer(3,rsima1);
      SetIndexLabel(3,NULL);
      SetIndexStyle(3,DRAW_NONE);       
      SetIndexBuffer(4,rsima2);
      SetIndexLabel(4,NULL);
      SetIndexStyle(4,DRAW_NONE);       
      SetIndexBuffer(5,rsi);
      SetIndexLabel(5,"rsi");       
      SetIndexStyle(5,DRAW_NONE);

      Recalculate=true;
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
{
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
   int    limit;
   int counted_bars=IndicatorCounted();
   
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 ) limit=depth;
   if ( counted_bars < 1 )
      for(int i=1;i<depth+smooth+period;i++) 
         {
         rsi[Bars-i]=0;    
         rsima1[Bars-i]=0;  
         rsima2[Bars-i]=0;    
         delta[Bars-i]=0;  
         delta1[Bars-i]=0;    
         }    
   
   if (GlobalVariableGet("reset") !=0 && ea_feedback)
      {
       Recalculate=true;
       IndicatorShortName("  ");
      }
   else  IndicatorShortName("BBRSI("+period+","+smooth+","+mode+","+price+")");

   if (Recalculate)
      {
      if (ea_feedback)
         {
         period=GlobalVariableGet("period");
         smooth=GlobalVariableGet("smooth");
         price= GlobalVariableGet("a_price");
         mode=  GlobalVariableGet("mode");
         TF=    GlobalVariableGet("trend_tf");
         }

       for(i=1;i<depth+smooth+period;i++) 
         {
         rsi[Bars-i]=0;    
         rsima1[Bars-i]=0;  
         rsima2[Bars-i]=0;    
         delta[Bars-i]=0;  
         delta1[Bars-i]=0;    
         }     

      SetLevelValue(1,1);
      SetLevelValue(2,-1);
      SetLevelValue(3,2);
      SetLevelValue(4,-2);
      limit=depth;
      }
      
   i=limit;     
   while(i >-1)  
      {
      rsi[i]=iRSI(Symbol(),TF,period,price,i);
      i--;
      }
      ArraySetAsSeries(rsi,true);
      
   i=limit;
   while(i >-1)  
      {
      rsima1[i]=iMAOnArray(rsi,0,smooth,0,mode,i);
      rsima2[i]=iMAOnArray(rsi,0,MathRound(smooth/2),0,mode,i);
      i--;
      }

   i=limit;
   while(i >-1)
      {
      delta[i]=NormalizeDouble(rsima2[i]-rsima1[i],1);
      if ((delta[i]>0 && delta[i]>delta1[i+1]) || (delta[i]<0 && delta[i]<delta1[i+1])) 
         {
         delta1[i]=delta[i];
         }
      else delta1[i]=delta1[i+1];
         
      trend[i]=0;

      if ((delta1[i]<0 && delta1[i]==delta1[i+1] && delta[i]>delta[i+1]) || (delta[i]>0 && delta[i]>delta[i+1])) 
         {
         trend[i]= 1;
         }
      if ((delta1[i]>0 && delta1[i]==delta1[i+1] && delta[i]<delta[i+1]) || (delta[i]<0 && delta[i]<delta1[i+1])) 
         {
         trend[i]=-1;
         }
      if (delta1[i]==delta1[i+1] && delta[i]==delta[i+1]) trend[i]=0;
      if (rsi[i]<=oversold) trend[i]=-2;
      if (rsi[i]>=overbought) trend[i]= 2;
      i--;
      }
                     
   if (Recalculate==true) {WindowRedraw();Recalculate=false;}
return(0);
}

